"""File MenuTest_WithMeatAndCheese.py  Test the Menu widget with event handling"""

from Tkinter import *
import tkMessageBox

class Application(Frame):
    def __init__(self, master=None):
        Frame.__init__(self, master)
        self.master.title("Menu Example")
        self.grid()
        self._breadVar = StringVar()
        self._mayoVar = IntVar()
        self._ketchupVar = IntVar()
        self._beefVar = IntVar()
        self._hamVar = IntVar()
        self._turkeyVar = IntVar()
        self._salamiVar = IntVar()
        self._cheddarVar = IntVar()
        self._havartiVar = IntVar()
        self._pepperJackVar = IntVar()
        self._swissVar = IntVar()
        self._createWidgets()

    def _createWidgets(self):
        breadMenubutton = Menubutton(self, text="Bread", relief=RAISED)
        breadMenubutton.grid(row=0, column=0, sticky=N+W+E)
        self.rowconfigure(0, pad=100)
        
        breadMenubutton.menu = Menu(breadMenubutton, tearoff=1)
        breadMenubutton["menu"] = breadMenubutton.menu
        breadMenubutton.menu.add_radiobutton(label="white", variable=self._breadVar)
        breadMenubutton.menu.add_radiobutton(label="wheat", variable=self._breadVar)
        breadMenubutton.menu.add_radiobutton(label="rye", variable=self._breadVar)


        condimentsMenubutton = Menubutton(self, text="Condiments", relief=RAISED)
        condimentsMenubutton.grid(row=0, column=1, sticky=N+W+E)
        
        condimentsMenubutton.menu = Menu(condimentsMenubutton, tearoff=0)
        condimentsMenubutton["menu"] = condimentsMenubutton.menu

        condimentsMenubutton.menu.add_checkbutton( label="mayo", variable=self._mayoVar)
        condimentsMenubutton.menu.add_checkbutton( label="ketchup", variable=self._ketchupVar)
        
        meatsMenubutton = Menubutton(self, text="Meats", relief=RAISED)
        meatsMenubutton.grid(row=0, column=2, sticky=N+W+E)
        
        meatsMenubutton.menu = Menu(meatsMenubutton, tearoff=0)
        meatsMenubutton["menu"] = meatsMenubutton.menu

        meatsMenubutton.menu.add_checkbutton( label="Beef", variable=self._beefVar)
        meatsMenubutton.menu.add_checkbutton( label="Ham", variable=self._hamVar)
        meatsMenubutton.menu.add_checkbutton( label="Turkey", variable=self._turkeyVar)
        meatsMenubutton.menu.add_checkbutton( label="Salami", variable=self._salamiVar)

        cheesesMenubutton = Menubutton(self, text="Cheeses", relief=RAISED)
        cheesesMenubutton.grid(row=0, column=3, sticky=N+W+E)
        
        cheesesMenubutton.menu = Menu(cheesesMenubutton, tearoff=0)
        cheesesMenubutton["menu"] = cheesesMenubutton.menu

        cheesesMenubutton.menu.add_checkbutton( label="Cheddar", variable=self._cheddarVar)
        cheesesMenubutton.menu.add_checkbutton( label="Havarti", variable=self._havartiVar)
        cheesesMenubutton.menu.add_checkbutton( label="Pepper Jack", variable=self._pepperJackVar)
        cheesesMenubutton.menu.add_checkbutton( label="Swiss", variable=self._swissVar)

        doneButton = Button(self, text='Click when done', command=self._readSelections)
        doneButton.grid(row=3, column=0, columnspan=4,sticky=W+E)

    def _readSelections(self):
        order = "Bread: "+self._breadVar.get()+"\nCondiments: "
        if self._mayoVar.get() == 1:
            order += "mayo "
        if self._ketchupVar.get() == 1:
            order += "ketchup "
        order += "\nMeats: "
        if self._beefVar.get() == 1:
            order += "beef "
        if self._hamVar.get() == 1:
            order += "ham "
        if self._turkeyVar.get() == 1:
            order += "turkey "
        if self._salamiVar.get() == 1:
            order += "salami "
        order += "\nCheeses: "
        if self._cheddarVar.get() == 1:
            order += "cheddar "
        if self._havartiVar.get() == 1:
            order += "havarti "
        if self._pepperJackVar.get() == 1:
            order += "pepper jack "
        if self._swissVar.get() == 1:
            order += "swiss "
            
        tkMessageBox.showinfo(title="Complete Order", message=order)

# end class Application

def main():
    """Instantiate and pop up the window."""
    Application().mainloop()

main()
